<template>
  <div class="">
    <el-card class="box-card">
      <div slot="header" class="clearfix">
        <span>{{ selectedRow ? selectedRow.partName : '名称' }}</span>
        <el-button style="float: right; padding: 3px 0" type="text" @click="handleAdd">添加摄像头</el-button>
      </div>
      <!-- 在这里可以添加其他逻辑，根据 selectedRow 渲染内容 -->
      <el-table v-loading="loading" :data="tableList" @selection-change="handleSelectionChange">
        <!-- <el-table-column type="selection" width="55" align="center" /> -->
        <el-table-column label="序号" align="center" type="index" width="50"/>
        <el-table-column label="摄像头名称" align="center" prop="cameraName" />
        <el-table-column label="摄像头编码" align="center" prop="cameraNum" />
        <el-table-column label="摄像头通道编号" align="center" prop="cameraPassNum" />
        <!-- <el-table-column label="摄像头ip" align="center" prop="cameraIp" /> -->
        <el-table-column label="摄像头url" align="center" prop="cameraUrl" />
        <el-table-column label="状态" align="center" prop="status">
        <template slot-scope="scope">
          <el-tag v-if="scope.row.status==1">正常</el-tag>
          <el-tag v-else type="warning">异常</el-tag>
        </template>
      </el-table-column>
        <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
          <template slot-scope="scope">
            <el-button
              size="mini"
              type="text"
              icon="el-icon-edit"
              @click="handleUpdate(scope.row)"
            >修改</el-button>
            <el-button
              size="mini"
              type="text"
              icon="el-icon-delete"
              @click="handleDelete(scope.row)"
            >删除</el-button>
          </template>
        </el-table-column>
      </el-table>

      <pagination
        v-show="total>0"
        :total="total"
        :page.sync="queryParams.pageNum"
        :limit.sync="queryParams.pageSize"
        @pagination="getList"
      />
    </el-card>
    <!-- 添加或修改摄像头对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="700px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="100px">
        <el-form-item label="摄像头名称" prop="cameraName">
          <el-input v-model="form.cameraName" placeholder="请输入摄像头名称" />
        </el-form-item>
        <el-form-item label="摄像头编码" prop="cameraNum">
          <el-input v-model="form.cameraNum" placeholder="请输入摄像头编码" />
        </el-form-item>
        <el-form-item label="通道编号" prop="cameraPassNum">
          <el-input v-model="form.cameraPassNum" placeholder="请输入摄像头通道编号" />
        </el-form-item>
        <!-- <el-form-item label="摄像头ip" prop="cameraIp">
          <el-input v-model="form.cameraIp" placeholder="请输入摄像头ip" />
        </el-form-item> -->
        <el-form-item label="摄像头url" prop="cameraUrl">
          <el-input v-model="form.cameraUrl" placeholder="请输入摄像头url" />
        </el-form-item>
 
    
       
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {getVideoTable, listVideoTable, addVideoTable, updateVideoTable, delVideoTable } from "@/api/tyler/videoTable";
export default {
  name: "videoRight",
  props: {
    selectedRow: {
      type: Object,
      default: null,
    },
  },
  data() {
    return {
      // 根路径
      baseURL: process.env.VUE_APP_BASE_API,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 摄像头表格数据
      tableList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        cameraName: null,
        cameraNum: null,
        cameraPassNum: null,
        cameraIp: null,
        cameraUrl: null,
        partId: null,
        cameraWeizhi: null,
        flag: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        id: [
          { required: true, message: "不能为空", trigger: "blur" }
        ],
      }
    };
  },
  created() {
   
    // this.getList();
  },
  watch: {
    // 监听 selectedRow 的变化
    selectedRow: {
      immediate: true, // 立即执行
      handler(newVal) {
        if (newVal) {
          this.queryParams.partId = newVal.id
          this.getList();
        }
      },
    },
  },
  methods: {
    /** 查询摄像头列表 */
    getList() {
      this.loading = true;
      listVideoTable(this.queryParams).then(response => {
        this.tableList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        cameraName: null,
        cameraNum: null,
        cameraPassNum: null,
        cameraIp: null,
        cameraUrl: null,
        partId: null,
        remark: null,
        cameraWeizhi: null,
        flag: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.form.partId = this.selectedRow.id
      this.title = "添加摄像头";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getVideoTable(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改摄像头";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateVideoTable(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addVideoTable(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除？').then(function() {
        return delVideoTable(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
  
  },
};
</script>